/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include <activemq/connector/openwire/commands/TransactionId.h>
#include <activemq/exceptions/ActiveMQException.h>
#include <decaf/lang/exceptions/NullPointerException.h>
#include <memory>

using namespace std;
using namespace activemq;
using namespace activemq::exceptions;
using namespace activemq::connector;
using namespace activemq::connector::openwire;
using namespace activemq::connector::openwire::commands;
using namespace decaf::lang::exceptions;

/*
 *
 *  Command and marshaling code for OpenWire format for TransactionId
 *
 *
 *  NOTE!: This file is autogenerated - do not modify!
 *         if you need to make a change, please see the Java Classes in the
 *         activemq-core module
 *
 */
////////////////////////////////////////////////////////////////////////////////
TransactionId::TransactionId()
{
}

////////////////////////////////////////////////////////////////////////////////
TransactionId::~TransactionId()
{
}

////////////////////////////////////////////////////////////////////////////////
TransactionId* TransactionId::cloneDataStructure() const {
    std::auto_ptr<TransactionId> transactionId( new TransactionId() );

    // Copy the data from the base class or classes
    transactionId->copyDataStructure( this );

    return transactionId.release();
}

////////////////////////////////////////////////////////////////////////////////
void TransactionId::copyDataStructure( const DataStructure* src ) {

    // Copy the data of the base class or classes
    BaseDataStructure::copyDataStructure( src );

    const TransactionId* srcPtr = dynamic_cast<const TransactionId*>( src );

    if( srcPtr == NULL || src == NULL ) {

        throw decaf::lang::exceptions::NullPointerException(
            __FILE__, __LINE__,
            "TransactionId::copyDataStructure - src is NULL or invalid" );
    }
}

////////////////////////////////////////////////////////////////////////////////
unsigned char TransactionId::getDataStructureType() const {
    return TransactionId::ID_TRANSACTIONID;
}

////////////////////////////////////////////////////////////////////////////////
std::string TransactionId::toString() const {

    ostringstream stream;

    stream << "Begin Class = TransactionId" << std::endl;
    stream << " Value of TransactionId::ID_TRANSACTIONID = 0" << std::endl;
    stream << BaseDataStructure::toString();
    stream << "End Class = TransactionId" << std::endl;

    return stream.str();
}

////////////////////////////////////////////////////////////////////////////////
bool TransactionId::equals( const DataStructure* value ) const {
    const TransactionId* valuePtr = dynamic_cast<const TransactionId*>( value );

    if( valuePtr == NULL || value == NULL ) {
        return false;
    }
    if( !BaseDataStructure::equals( value ) ) {
        return false;
    }
    return true;
}

